% ======================================================================
%> @brief Merge all the .csv files generated by the simulation in one
%			unique .csv file, taking in account also transparency files.
%>
%> @param simulation_dir Directory of the .csv files to merge
%> @param simulation_name Name of the simulation under analysis
%> @param config_name Configuration name under analysis
%>
%> @retval csv The table saved in the new unique .csv file
% ======================================================================
function csv = Unique_csv_Forecast(simulation_dir, simulation_name, config_name)

	% add final slash in the simulation_dir if it doesn't exist
	if(~endsWith(simulation_dir,'/'))
		simulation_dir = [simulation_dir '/'];
    end
    
    % make the simulation_dir or clear it
    if(~exist(simulation_dir, 'dir'))
       mkdir(simulation_dir)
    else
        % remove old .csv files
        files_to_remove = dir([simulation_dir simulation_name '*.csv']);
        for i = 1:size(files_to_remove,1)
            if (exist([simulation_dir files_to_remove(i).name], 'file')==2)
                delete([simulation_dir files_to_remove(i).name])
            end
        end
    end

	% forecast directories
	forecast_logs_dir = '~/forecast/logs/';
	forecast_presets_dir = '~/forecast/presets/';
	
	% copy the .yaml file in the simulation_dir
	copyfile([forecast_presets_dir simulation_name '.yaml'],simulation_dir)
	
	% take the .csv in the forecast logs directory
	files = dir([forecast_logs_dir  simulation_name '*=*.csv']);
	[n_csv,~] = size(files);

	% take the .yaml file
	yamlFile = ReadYaml([simulation_dir simulation_name '.yaml']);
	
	% move the .csv files from forecast to simulation_dir
	for index=1:n_csv
		tt = readtable([forecast_logs_dir files(index).name]);
		
		if(strfind(files(index).name, 'transparency') > 0)
			tt.Properties.VariableNames = {'t','ref','tau','err','theta_m','dtheta_m','ddtheta_m','tau_s','tau_m','theta_e'};
		else
			tt.Properties.VariableNames = {'t','ref','tau','err'};
		end
		
		% remove useless chars created by the UI
		new_name = eraseBetween(files(index).name,'end','.csv');
		new_name = eraseBetween(new_name,'control','.csv');
		delete([forecast_logs_dir files(index).name])
		writetable(tt,[simulation_dir new_name]);
	end
	
	% take the .csv in the simulation directory
	files = dir([simulation_dir  simulation_name '*=*.csv']);
	[n_csv,~] = size(files);

	% do only for simulations with transparency enabled
	if(yamlFile.(config_name).transparency.enable_transparency)
		count_transp_csv = 0;
		index = n_csv;
		
		while index > 0
			if(strfind(files(index).name, 'transparency') > 0)
				% swapping files order
				tmp = files(index);
				files(index) = files(end-count_transp_csv);
				files(end-count_transp_csv) = tmp;
				count_transp_csv = count_transp_csv +1;
			end
			index = index -1;
		end
	end

	csv_cells = {};
	matrix_rows = inf;
	colsXcsv = [];
	Ts = 0;
	
	for index=1:n_csv
		% csv file names
		csv_cells{1,index} = readtable([simulation_dir files(index).name]);
		
		tmp_Ts = 1/(mean(diff(csv_cells{1,index}.t)));

		if (tmp_Ts > Ts)
			Ts = tmp_Ts;
		end

		[row,cols] = size(csv_cells{1,index});

		colsXcsv(index) = cols;

		if (row < matrix_rows)
			matrix_rows = row;
		end
	end

	cols = 4;

	% the final csv matrix
	matrix = zeros(matrix_rows,(2+(cols-2)*n_csv));
	timeVect = 0:1/Ts:matrix_rows/Ts-1/Ts;

	col_index = 3;
	matrix(:,1) = timeVect;
	matrix(:,2) = csv_cells{1,1}.ref(1:matrix_rows);

	% copy all data
	for index = 1:n_csv
		T = csv_cells{1,index};

		for col = 3:colsXcsv(index)
			curr_col = table2array(T(1:matrix_rows,col));

			matrix(:,col_index) = resample(curr_col,timeVect,Ts);

			col_index = col_index + 1;
		end
	end

	% labelling the cols
	labels = {};

	labels{1,1} = 't';
	labels{1,2} = 'ref';

	col_index = 3;
	for index = 1:n_csv
		extLabels = csv_cells{1,index}.Properties.VariableNames;
		for cycle = 3:colsXcsv(index)
			labels{1,col_index} = strcat(files(index).name(1:end-4),strcat('_',extLabels{1,cycle}));
			col_index = col_index +1;
		end

		% remove all the .csv used
		if (exist([simulation_dir files(index).name], 'file')==2)
% 			delete([directory files(index).name]);
		end
	end

	% create and save the new unique .csv
	csv = array2table(matrix,'VariableNames',labels);
	writetable(csv,[simulation_dir simulation_name '.csv'],'Delimiter',';');
end